Summary:        CPU frequency adjusting daemon
Name:           cpuspeed
Version:        1.2.1
Release:        5%{?dist}
Epoch:          1
Group:          System Environment/Base
License:        GPL
URL:            http://carlthompson.net/Software/CPUSpeed
Source0:        http://carlthompson.net/dl/cpuspeed/cpuspeed-%{version}.tar.gz
Source1:        cpuspeed.init
Source2:        http://carlthompson.net/dl/cpuspeed/license.txt
Source3:        cpuspeed.conf
Source4:        cpuspeed.8
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post):  /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service

BuildRequires:  automake util-linux groff gettext
ExclusiveArch:	i386 x86_64 ppc ppc64 ia64
Obsoletes:	kernel-utils

Patch1: warning.diff
Patch2: idlenice.diff
Patch3: nostrip.diff

%description
cpuspeed is a daemon that dynamically changes the speed
of your processor(s) depending upon its current workload
if it is capable (needs Intel Speedstep, AMD PowerNow!,
or similar support).

This package also supports enabling cpu frequency scaling
via in-kernel governors on Intel Centrino and AMD
Athlon64/Opteron platforms.

%prep
%setup -q

cp %{SOURCE2} .

%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
rm -rf $RPM_BUILD_ROOT

mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_mandir}/man8/

make CFLAGS="$RPM_OPT_FLAGS -fpie -pie -Wl,-z,relro,-z,now"

%install
install cpuspeed %{buildroot}%{_sbindir}
install %{SOURCE1} %{buildroot}%{_sysconfdir}/rc.d/init.d/cpuspeed
install %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/cpuspeed
install %{SOURCE4} %{buildroot}%{_mandir}/man8/cpuspeed.8

chmod -R a-s %{buildroot}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-,root,root,-)
%doc license.txt CHANGES EXAMPLES FEATURES README USAGE
%{_sbindir}/cpuspeed
%{_sysconfdir}/rc.d/init.d/cpuspeed
%{_mandir}/man8/*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/cpuspeed

%preun
if [ "$1" = "0" ] ; then
  /sbin/service cpuspeed stop >/dev/null 2>&1 || :
  /sbin/chkconfig --del cpuspeed
fi

%post
/sbin/chkconfig --add cpuspeed

%triggerpostun -- kernel-utils
/sbin/chkconfig --add cpuspeed
exit 0

%changelog
* Wed Sep 24 2008 Jarod Wilson <jarod@redhat.com> 1.2.1-5
- Support for speedstep-centrino module fallback if
  new-and-improved acpi-cpufreq doesn't work (#463488)

* Tue Aug 19 2008 Jarod Wilson <jarod@redhat.com> 1.2.1-4
- Support for powernow-k8 as a kernel module (#459441)

* Thu Mar 06 2008 Jarod Wilson <jwilson@redhat.com> 1.2.1-3
- Disable freq scaling by default on AMD rev F and earlier
  cpus when running xen, due to clock instability (#435321)

* Tue Dec 11 2007 Jarod Wilson <jwilson@redhat.com> 1.2.1-2
- We have initial frequency scaling support for xen
  kernels now, so try running on xen (#419291)

* Wed Jun 27 2007 Jarod Wilson <jwilson@redhat.com>
- Additional initscript exit code cleanups (#237940)

* Mon May 21 2007 Jarod Wilson <jwilson@redhat.com>
- Fix up exit codes for LSB compliance (#237940)
- Try loading acpi-cpufreq even on systems that don't
  report enhanced speedstep support (#216702)
- Indentation and variable usage cleanup

* Wed Jan 17 2007 Jarod Wilson <jwilson@redhat.com>
- Clean up initscript output & catch undef var (#213999)

* Thu Jan 11 2007 Jarod Wilson <jwilson@redhat.com>
- Fix error-suppression for systems that report support
  for est, but have it disabled in the bios (#220200)

* Thu Jan 11 2007 Jarod Wilson <jwilson@redhat.com>
- Fix up documentation in config file (#219926)
- Fall back cleanly to userspace governor on
  non-centrino/powernow-k8/p4-clockmod systems
- Update description to reflect support for
  kernel-space freq scaling

* Wed Jan 10 2007 Jarod Wilson <jwilson@redhat.com>
- Fix valid governor check
- Use ondemand by default on p4-clockmod systems (#222199)

* Wed Jan 10 2007 Jarod Wilson <jwilson@redhat.com>
- Turn on ia64 builds (#216702)
- Fix status on xen kernels
- Move config file to /etc/sysconfig/cpuspeed, more
  appropriate for initscript configs (#152305)
- Manify 'cpuspeed --help' along with other details (#172655)
- Tweak cpuspeed default thresholds (#147565)
- Let non-centrino/powernow-k8 systems also use other
  validated governors (#219926)
- Fix cpuspeed daemon options settings (#221829)
- Fix status and condrestart for centrino/powernow-k8 (#219926)
- Give feedback when loading/unloading a cpufreq governor
- Rework config file and initscript to make it much easier
  for end-users to adjust frequency scaling setup (#151761)
- Log start/stop events with useful info
- Don't start on xen kernels (freq scaling not supported)
- Set lock file for centrino/powernow-k8 so status 
  indicates we do have scaling working 
- Fix up centrino/powernow-k8 stop function (#213999)

* Wed Nov 29 2006 Jarod Wilson <jwilson@redhat.com>
- Fix busted config file sourcing

* Mon Nov 27 2006 Jarod Wilson <jwilson@redhat.com>
- Spec tweaks to bring in line with Fedora packaging guidelines
- Add docs to package
- Mark config file as noreplace
- Be sure to stop service before uninstall

* Tue Nov 21 2006 Dave Jones <davej@redhat.com>
- Merge one more patch from Michal Jaegermann <michal@harddata.com> (#216816)

* Mon Nov 20 2006 Dave Jones <davej@redhat.com>
- Merge patch from Michal Jaegermann <michal@harddata.com>
  that solves the acpi-cpufreq problem in an improved
  way and fixes several other nits.

* Sat Oct 28 2006 Dave Jones <davej@redhat.com>
- Only load acpi-cpufreq on speedstep capable machines.
- Unload acpi-cpufreq if BIOS tables didn't exist or
  other acpi-cpufreq failures occured.

* Sat Jul 29 2006 Dave Jones <davej@redhat.com>
- Don't try to load acpi-cpufreq on non-ACPI machines. (#196446)

* Wed Jul 26 2006 Dave Jones <davej@redhat.com>
- Fix up retval & /var/lock/subsys/cpuspeed handling in initscript.

* Thu Jul 20 2006 Jim Paradis <jparadis@redhat.com>
- Enable on-demand governor usage for powernow-k8 as well as centrino

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1:1.2.1-1.35%{dist}.1
- rebuild

* Sat Jul  1 2006 Dave Jones <davej@redhat.com>
- Fix sched_mc_power_savings warning on centrino laptops.

* Wed Jun  7 2006 Dave Jones <davej@redhat.com>
- Remove a bunch of no-longer needed gunk from the initscript.
- Use on-demand governor on centrino/core based systems for now,
  as it seems to have a better effect.

* Thu Feb 23 2006 Dave Jones <davej@redhat.com>
- Fix broken init script. (Alexandre Oliva) [#182691]
  Taking ugly shell script to the next level.

* Tue Feb 21 2006 Dave Jones <davej@redhat.com>
- Missed another occurance of the same problem I fixed yesterday.

* Mon Feb 20 2006 Dave Jones <davej@redhat.com>
- Some ACPI BIOSes start counting CPUs at 0, some at 1. *sigh*  (#181673)

* Sat Feb 11 2006 Dave Jones <davej@redhat.com>
- rebuild.

* Thu Feb 09 2006 Dave Jones <davej@redhat.com>
- rebuild.

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcj

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon Nov 14 2005 Dave Jones <davej@redhat.com>
- Don't try and load acpi-cpufreq if we have no throttling states.

* Thu Sep 29 2005 Dave Jones <davej@redhat.com>
- On shutdown, restore speed to maximum before daemon exit.

* Fri Sep 23 2005 Dave Jones <davej@redhat.com>
- Use ACPI as a fallback driver if possible, if one didn't get loaded. (#160788)

* Mon May  9 2005 Dave Jones <davej@redhat.com>
- Fix debuginfo generation.

* Wed Apr  6 2005 Dave Jones <davej@redhat.com>
- Don't count nice time as idle time. (#132383)

* Tue Mar  1 2005 Dave Jones <davej@redhat.com>
- Rebuild for gcc4.

* Tue Feb  8 2005 Dave Jones <davej@redhat.com>
- Rebuild with -D_FORTIFY_SOURCE=2

* Fri Feb  4 2005 Dave Jones <davej@redhat.com>
- Enable builds for PPC (#147089)

* Tue Jan 11 2005 Dave Jones <davej@redhat.com>
- Add missing Obsoletes: kernel-utils

* Mon Jan 10 2005 Dave Jones <davej@redhat.com>
- Update to upstream 1.2.1 release.

* Sat Dec 18 2004 Dave Jones <davej@redhat.com>
- Initial packaging, split out from kernel-utils.

